/// <reference types="react" />
import { popupInstance, PopupProps } from '../popupsDef';
import { PopupItem } from './PopupItem';
import { PopupManager } from '../popupManager';
export declare type OpenPopupOptions<T> = Omit<T & PopupProps, 'isOpen'>;
export declare class PopupManagerInternal implements PopupManager {
    private openPopups;
    private readonly _closedPopups;
    onPopupsChangeEvents: Function[];
    private callPopupsChangeEvents;
    private get closedPopups();
    subscribeOnPopupsChange(callback: Function): void;
    get popups(): PopupItem[];
    open: <T>(componentClass: import("react").ComponentType<T>, popupProps?: OpenPopupOptions<T>) => popupInstance;
    close(popupGuid: string, onConsumerOnCloseCallback?: Function, args?: any[]): void;
    private unmount;
    closeAll: () => void;
}
